// Code generated by go-swagger; DO NOT EDIT.

package run_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new run service API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for run service API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
RunServiceArchiveRunV1 archives a run
*/
func (a *Client) RunServiceArchiveRunV1(params *RunServiceArchiveRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceArchiveRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceArchiveRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_ArchiveRunV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs/{id}:archive",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceArchiveRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceArchiveRunV1OK), nil

}

/*
RunServiceCreateRunV1 creates a new run
*/
func (a *Client) RunServiceCreateRunV1(params *RunServiceCreateRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceCreateRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceCreateRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_CreateRunV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceCreateRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceCreateRunV1OK), nil

}

/*
RunServiceDeleteRunV1 deletes a run
*/
func (a *Client) RunServiceDeleteRunV1(params *RunServiceDeleteRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceDeleteRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceDeleteRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_DeleteRunV1",
		Method:             "DELETE",
		PathPattern:        "/apis/v1beta1/runs/{id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceDeleteRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceDeleteRunV1OK), nil

}

/*
RunServiceGetRunV1 finds a specific run by ID
*/
func (a *Client) RunServiceGetRunV1(params *RunServiceGetRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceGetRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceGetRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_GetRunV1",
		Method:             "GET",
		PathPattern:        "/apis/v1beta1/runs/{run_id}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceGetRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceGetRunV1OK), nil

}

/*
RunServiceListRunsV1 finds all runs
*/
func (a *Client) RunServiceListRunsV1(params *RunServiceListRunsV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceListRunsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceListRunsV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_ListRunsV1",
		Method:             "GET",
		PathPattern:        "/apis/v1beta1/runs",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceListRunsV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceListRunsV1OK), nil

}

/*
RunServiceReadArtifactV1 finds a run s artifact data
*/
func (a *Client) RunServiceReadArtifactV1(params *RunServiceReadArtifactV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceReadArtifactV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceReadArtifactV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_ReadArtifactV1",
		Method:             "GET",
		PathPattern:        "/apis/v1beta1/runs/{run_id}/nodes/{node_id}/artifacts/{artifact_name}:read",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceReadArtifactV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceReadArtifactV1OK), nil

}

/*
RunServiceReportRunMetricsV1 reports run metrics reports metrics of a run each metric is reported in its own transaction so this API accepts partial failures metric can be uniquely identified by run id node id name duplicate reporting will be ignored by the API first reporting wins
*/
func (a *Client) RunServiceReportRunMetricsV1(params *RunServiceReportRunMetricsV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceReportRunMetricsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceReportRunMetricsV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_ReportRunMetricsV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs/{run_id}:reportMetrics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceReportRunMetricsV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceReportRunMetricsV1OK), nil

}

/*
RunServiceRetryRunV1 res initiates a failed or terminated run
*/
func (a *Client) RunServiceRetryRunV1(params *RunServiceRetryRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceRetryRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceRetryRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_RetryRunV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs/{run_id}/retry",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceRetryRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceRetryRunV1OK), nil

}

/*
RunServiceTerminateRunV1 terminates an active run
*/
func (a *Client) RunServiceTerminateRunV1(params *RunServiceTerminateRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceTerminateRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceTerminateRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_TerminateRunV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs/{run_id}/terminate",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceTerminateRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceTerminateRunV1OK), nil

}

/*
RunServiceUnarchiveRunV1 restores an archived run
*/
func (a *Client) RunServiceUnarchiveRunV1(params *RunServiceUnarchiveRunV1Params, authInfo runtime.ClientAuthInfoWriter) (*RunServiceUnarchiveRunV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewRunServiceUnarchiveRunV1Params()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "RunService_UnarchiveRunV1",
		Method:             "POST",
		PathPattern:        "/apis/v1beta1/runs/{id}:unarchive",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &RunServiceUnarchiveRunV1Reader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*RunServiceUnarchiveRunV1OK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
