// Code generated by go-swagger; DO NOT EDIT.

package pipeline_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPipelineServiceListPipelinesParams creates a new PipelineServiceListPipelinesParams object
// with the default values initialized.
func NewPipelineServiceListPipelinesParams() *PipelineServiceListPipelinesParams {
	var ()
	return &PipelineServiceListPipelinesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPipelineServiceListPipelinesParamsWithTimeout creates a new PipelineServiceListPipelinesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPipelineServiceListPipelinesParamsWithTimeout(timeout time.Duration) *PipelineServiceListPipelinesParams {
	var ()
	return &PipelineServiceListPipelinesParams{

		timeout: timeout,
	}
}

// NewPipelineServiceListPipelinesParamsWithContext creates a new PipelineServiceListPipelinesParams object
// with the default values initialized, and the ability to set a context for a request
func NewPipelineServiceListPipelinesParamsWithContext(ctx context.Context) *PipelineServiceListPipelinesParams {
	var ()
	return &PipelineServiceListPipelinesParams{

		Context: ctx,
	}
}

// NewPipelineServiceListPipelinesParamsWithHTTPClient creates a new PipelineServiceListPipelinesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPipelineServiceListPipelinesParamsWithHTTPClient(client *http.Client) *PipelineServiceListPipelinesParams {
	var ()
	return &PipelineServiceListPipelinesParams{
		HTTPClient: client,
	}
}

/*PipelineServiceListPipelinesParams contains all the parameters to send to the API endpoint
for the pipeline service list pipelines operation typically these are written to a http.Request
*/
type PipelineServiceListPipelinesParams struct {

	/*Filter
	  A url-encoded, JSON-serialized filter protocol buffer (see
	[filter.proto](https://github.com/kubeflow/pipelines/blob/master/backend/api/filter.proto)).

	*/
	Filter *string
	/*Namespace
	  Optional input. Namespace for the pipelines.

	*/
	Namespace *string
	/*PageSize
	  The number of pipelines to be listed per page. If there are more pipelines
	than this number, the response message will contain a valid value in the
	nextPageToken field.

	*/
	PageSize *int32
	/*PageToken
	  A page token to request the results page.

	*/
	PageToken *string
	/*SortBy
	  Sorting order in form of "field_name", "field_name asc" or "field_name desc".
	Ascending by default.

	*/
	SortBy *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithTimeout(timeout time.Duration) *PipelineServiceListPipelinesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithContext(ctx context.Context) *PipelineServiceListPipelinesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithHTTPClient(client *http.Client) *PipelineServiceListPipelinesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFilter adds the filter to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithFilter(filter *string) *PipelineServiceListPipelinesParams {
	o.SetFilter(filter)
	return o
}

// SetFilter adds the filter to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetFilter(filter *string) {
	o.Filter = filter
}

// WithNamespace adds the namespace to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithNamespace(namespace *string) *PipelineServiceListPipelinesParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetNamespace(namespace *string) {
	o.Namespace = namespace
}

// WithPageSize adds the pageSize to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithPageSize(pageSize *int32) *PipelineServiceListPipelinesParams {
	o.SetPageSize(pageSize)
	return o
}

// SetPageSize adds the pageSize to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetPageSize(pageSize *int32) {
	o.PageSize = pageSize
}

// WithPageToken adds the pageToken to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithPageToken(pageToken *string) *PipelineServiceListPipelinesParams {
	o.SetPageToken(pageToken)
	return o
}

// SetPageToken adds the pageToken to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetPageToken(pageToken *string) {
	o.PageToken = pageToken
}

// WithSortBy adds the sortBy to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) WithSortBy(sortBy *string) *PipelineServiceListPipelinesParams {
	o.SetSortBy(sortBy)
	return o
}

// SetSortBy adds the sortBy to the pipeline service list pipelines params
func (o *PipelineServiceListPipelinesParams) SetSortBy(sortBy *string) {
	o.SortBy = sortBy
}

// WriteToRequest writes these params to a swagger request
func (o *PipelineServiceListPipelinesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Filter != nil {

		// query param filter
		var qrFilter string
		if o.Filter != nil {
			qrFilter = *o.Filter
		}
		qFilter := qrFilter
		if qFilter != "" {
			if err := r.SetQueryParam("filter", qFilter); err != nil {
				return err
			}
		}

	}

	if o.Namespace != nil {

		// query param namespace
		var qrNamespace string
		if o.Namespace != nil {
			qrNamespace = *o.Namespace
		}
		qNamespace := qrNamespace
		if qNamespace != "" {
			if err := r.SetQueryParam("namespace", qNamespace); err != nil {
				return err
			}
		}

	}

	if o.PageSize != nil {

		// query param page_size
		var qrPageSize int32
		if o.PageSize != nil {
			qrPageSize = *o.PageSize
		}
		qPageSize := swag.FormatInt32(qrPageSize)
		if qPageSize != "" {
			if err := r.SetQueryParam("page_size", qPageSize); err != nil {
				return err
			}
		}

	}

	if o.PageToken != nil {

		// query param page_token
		var qrPageToken string
		if o.PageToken != nil {
			qrPageToken = *o.PageToken
		}
		qPageToken := qrPageToken
		if qPageToken != "" {
			if err := r.SetQueryParam("page_token", qPageToken); err != nil {
				return err
			}
		}

	}

	if o.SortBy != nil {

		// query param sort_by
		var qrSortBy string
		if o.SortBy != nil {
			qrSortBy = *o.SortBy
		}
		qSortBy := qrSortBy
		if qSortBy != "" {
			if err := r.SetQueryParam("sort_by", qSortBy); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
