# V2beta1RecurringRun

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**recurring_run_id** | **str** | Output. Unique run ID generated by API server. | [optional] 
**display_name** | **str** | Required input field. Recurring run name provided by user. Not unique. | [optional] 
**description** | **str** | Optional input field. Describes the purpose of the recurring run. | [optional] 
**pipeline_version_id** | **str** | This field is Deprecated. The pipeline version id is under pipeline_version_reference for v2. | [optional] 
**pipeline_spec** | [**object**](.md) | The pipeline spec. | [optional] 
**pipeline_version_reference** | [**V2beta1PipelineVersionReference**](V2beta1PipelineVersionReference.md) |  | [optional] 
**runtime_config** | [**V2beta1RuntimeConfig**](V2beta1RuntimeConfig.md) |  | [optional] 
**service_account** | **str** | Optional input field. Specifies which Kubernetes service account this recurring run uses. | [optional] 
**max_concurrency** | **str** | Required input field. Specifies how many runs can be executed concurrently. Range [1-10]. | [optional] 
**trigger** | [**V2beta1Trigger**](V2beta1Trigger.md) |  | [optional] 
**mode** | [**RecurringRunMode**](RecurringRunMode.md) |  | [optional] 
**created_at** | **datetime** | Output. The time this recurring run was created. | [optional] 
**updated_at** | **datetime** | Output. The last time this recurring run was updated. | [optional] 
**status** | [**V2beta1RecurringRunStatus**](V2beta1RecurringRunStatus.md) |  | [optional] 
**error** | [**GooglerpcStatus**](GooglerpcStatus.md) |  | [optional] 
**no_catchup** | **bool** | Optional input field. Whether the recurring run should catch up if behind schedule. If true, the recurring run will only schedule the latest interval if behind schedule. If false, the recurring run will catch up on each past interval. | [optional] 
**namespace** | **str** | TODO (gkclat): consider removing this field if it can be obtained from the parent experiment. Output only. Namespace this recurring run belongs to. Derived from the parent experiment. | [optional] [readonly] 
**experiment_id** | **str** | ID of the parent experiment this recurring run belongs to. | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


